require 'sketchup.rb'
require "dl"
require "dl/import"
require "dl/struct"

module SDL
    if(PLATFORM=="i386-mswin32")    
      extend DL::Importable
      dlload(Sketchup.find_support_file("SDL.dll","plugins/Sketchyphysics3/sdl/"))
      extern "int SDL_Init(int)"
      extern "void* SDL_RWFromFile(char*, char*)"
      extern "void* SDL_RWFromMem(char*, int)"
      extern "char* SDL_GetError()"
        
      dlload(Sketchup.find_support_file("SDL_mixer.dll","plugins/Sketchyphysics3/sdl/"))
      extern "int Mix_OpenAudio(int,int,int,int)"
      extern "void Mix_CloseAudio()"
      extern "void* Mix_LoadWAV_RW(void*,int)"
      extern "int Mix_PlayChannelTimed(int, void*,int,int)"
      extern "void* Mix_LoadMUS_RW(void*)"
      extern "int Mix_PlayMusic(void*,int)"
      extern "void* SDL_RWFromMem(void*,int)"
      extern "int Mix_Volume(int, int)"
      extern "void Mix_SetPosition(int, int, int)"
      extern "void Mix_SetPanning(int, int, int)"
      extern "void Mix_SetDistance(int, int)"
      extern "void Mix_Pause(int)"
      extern "void Mix_Resume(int)"
    else
      extend DL::Importable
      dlload(Sketchup.find_support_file("SDL.dylib","plugins/SketchyPhysics3/sdl/"))
      extern "int SDL_Init(int)"
      extern "void* SDL_RWFromFile(char*, char*)"
      extern "void* SDL_RWFromMem(char*, int)"
      extern "char* SDL_GetError()"
      
      dlload(Sketchup.find_support_file("SDL_mixer.dylib","plugins/SketchyPhysics3/sdl/"))
      extern "int Mix_OpenAudio(int,int,int,int)"
      extern "void Mix_CloseAudio()"
      extern "void* Mix_LoadWAV_RW(void*,int)"
      extern "int Mix_PlayChannelTimed(int, void*,int,int)"
      extern "void* Mix_LoadMUS_RW(void*)"
      extern "int Mix_PlayMusic(void*,int)"
      extern "void* SDL_RWFromMem(void*,int)"
      extern "int Mix_Volume(int, int)"
      extern "void Mix_SetPosition(int, int, int)"
      extern "void Mix_SetPanning(int, int, int)"
      extern "void Mix_SetDistance(int, int)"
      extern "void Mix_Pause(int)"
      extern "void Mix_Resume(int)"
    end
end 
module MSketchyPhysics3

#~ ptr = DL.malloc(DL.sizeof('LL'))
#~ ptr.struct!('LL', :tv_sec, :tv_usec)
#~ ptr[:tv_sec] = 10
#~ ptr[:tv_usec] = 100
#~ sec = ptr[:tv_sec]
#~ usec = ptr[:tv_usec]


class SPSounds
    def initialize
        #not working on Mac yet.
        #return if(PLATFORM!="i386-mswin32")   
        
        SDL.sDL_Init(0x00000010)
        SDL.mix_OpenAudio(22050, 0x8010,  2, 512)
        @allSounds=Hash.new
        dict=Sketchup.active_model.attribute_dictionary("SPSounds")
        #return if dict==nil
        
        if dict!=nil
            dict.each{|name,data|
                if(data!=nil)
                    data=data.pack("C*")
                    #puts [name,data.length]
                    @allSounds[name]=SDL.mix_LoadWAV_RW(SDL.sDL_RWFromMem(data, data.length),0)
                end
            }
        end
        @allMusic=Hash.new
        dict=Sketchup.active_model.attribute_dictionary("SPMusic")
        return if dict==nil
        
        dict.each{|name,data|
            if(data!=nil)
                data=data.pack("C*")
                puts [name,data.length]
                @allMusic[name]=SDL.mix_LoadMUS_RW(SDL.sDL_RWFromMem(data, data.length))
                puts @allMusic[name]
            end
        }
    end
    def play(name)
        #not working on Mac yet.
        #return nil if(PLATFORM!="i386-mswin32")   
        snd=@allSounds[name]
        if(snd!=nil)
            return SDL.mix_PlayChannelTimed(-1, snd, 0,-1);
        end
    end
    def playMusic(name)
        puts "music"
        puts name
        #not working on Mac yet.
        #return if(PLATFORM!="i386-mswin32")   
        mus=@allMusic[name]
        puts mus
        if(mus!=nil)
            puts "music"
            puts SDL.mix_PlayMusic(mus,-1);
        end
    end
    def stopAll()
        SDL.mix_CloseAudio()
    end
end#class


def loadSound()
    
    #f=File.new("c:\\temp\\lame\\angstrom_c1.mp3","rb")
    #data=f.read
    #$cSound=SDL.mix_LoadWAV_RW(SDL.sDL_RWFromMem(data.to_ptr,data.length),0)
    #f.close
    fn=Sketchup.find_support_file("woodSound1.wav","plugins/SketchyPhysics3/Sounds/")
    
    $cSound=SDL.mix_LoadWAV_RW(SDL.sDL_RWFromFile(fn, "rb"),0)
    #$dSound=SDL.mix_LoadWAV_RW(SDL.sDL_RWFromFile("c:\\temp\\lame\\angstrom_d1.mp3", "rb"),0)
end
def testSound
    #f=SDL.sDL_RWFromFile("c:\\temp\\lame\\angstrom_c1.wav", "rb")
    #rw=SDL.sDL_RWFromMem(data.to_ptr,data.length)
    #snd=SDL.mix_LoadWAV_RW(rw,1);
    #puts SDL.sDL_GetError(); 
    SDL.mix_PlayChannelTimed(-1, $cSound, 0,-1);
    #SDL.mix_PlayChannelTimed(-1, $dSound, 0,-1);
end    

def exportEmbeddedSounds()
    dict=Sketchup.active_model.attribute_dictionary("SPSounds")
    dict.each{|name,data|
        if(data!=nil)
            data=data.pack("C*")
            outpath=Sketchup.find_support_file("plugins/SketchyPhysics3/Sounds/cache")
            outname=outpath+'/'+name
            puts ("writting:"+outname)
            f=File.new(outname,"wb")
            f.write(data)
            f.close
#            UI.play_sound(outname)
        end
    }
    
end

def playEmbedSound(name)
    
    name=File.basename(name, ".wav")
    
    data=Sketchup.active_model.get_attribute("SPSounds",name,nil)

    if(data!=nil)
        data=data.pack("C*")
        outpath=Sketchup.find_support_file("plugins/SketchyPhysics3/Sounds/cache")
        outname=outpath+'/'+name
        puts ("writting:"+outname)
        f=File.new(outname,"wb")
        f.write(data)
        f.close
        UI.play_sound(outname)
    end
end


def self.embedSound(fileName)
    name=File.basename(fileName,".wav")
    f=File.new(fileName,"rb")
    return if f==nil
    data=f.read
    f.close
    data=data.unpack("C*")
    Sketchup.active_model.set_attribute("SPSounds",name,data)
    return true
end
def self.embedMusic(fileName)
    name=File.basename(fileName,".ogg")
    f=File.new(fileName,"rb")
    return if f==nil
    data=f.read
    f.close
    data=data.unpack("C*")
    Sketchup.active_model.set_attribute("SPMusic",name,data)
    return true
end
##########################################################
$test_sound_class = SPSounds.new()

def $test_sound_class.refresh() #adds a refresh method to $test_sound_class instance of SPSounds
   	#not working on Mac yet.
   	#return if(PLATFORM!="i386-mswin32")   

   	@allSounds=Hash.new if(!defined?(@allSounds))
    dict=Sketchup.active_model.attribute_dictionary("SPSounds")
    #return if dict==nil
    if dict!=nil
        dict.each{|name,data|
            if(data!=nil)
                data=data.pack("C*")
                #puts [name,data.length]
                @allSounds[name]=SDL.mix_LoadWAV_RW(SDL.sDL_RWFromMem(data, data.length),0)
            end
        }
    end
    @allMusic=Hash.new if(!defined?(@allMusic))
    dict=Sketchup.active_model.attribute_dictionary("SPMusic")
    return if dict==nil
    dict.each{|name,data|
        if(data!=nil)
            data=data.pack("C*")
            puts [name,data.length]
            @allMusic[name]=SDL.mix_LoadMUS_RW(SDL.sDL_RWFromMem(data, data.length))
            puts @allMusic[name]
        end
    }
end

def $test_sound_class.playMusic(name,loopnumber=0) #added a loopnumber to set the number of loops
  #not working on Mac yet.
  return if(PLATFORM!="i386-mswin32")   
  mus=@allMusic[name]
  if(mus!=nil)
      puts SDL.mix_PlayMusic(mus,loopnumber);
  end
end

def self.soundEmbedder()
	dlg=UI::WebDialog.new("SoundUI 0.2",true,"soundemb1", 430, 460, 50, 50, true);
	html_path=Object::File.join( Object::File.dirname(__FILE__),"sketchyui/SoundUI.html")
	dlg.set_file(html_path)
	dlg.show
	dlg.add_action_callback("html_loaded"){|dialog, params|
	  dict=Sketchup.active_model.attribute_dictionary("SPSounds") #look for embedded sounds
    if dict!=nil
    	dict.each{|name,data| #add all present sounds to the html list
    		if(data!=nil)
    			js_command = "addToSelection('"+name+"','"+name+"','sound_list')"
	  			dlg.execute_script(js_command)
    		end
    	}
    end
    dict=Sketchup.active_model.attribute_dictionary("SPMusic") #look for embedded sounds
    if dict!=nil
    	dict.each{|name,data| #add all present music to the html list
    		if(data!=nil)
    			js_command = "addToSelection('"+name+"','"+name+"','music_list')"
	  			dlg.execute_script(js_command)
    		end
    	}
    end
	}
	dlg.add_action_callback("embed_sound"){|dialog, params|
	  path=Sketchup.find_support_file("plugins/SketchyPhysics3/Sounds/")
	  sound_file = UI.openpanel "Add Sound File", path, "*.wav"
	  if sound_file!=nil #and File.size?(sound_file)<550000 #if there is a file and is smaller then ~500kB
	  	if sound_file[-4,4]==".wav" #check if wav file
	  		if embedSound(sound_file) #if embedding was done add name to html selection
	  			name=File.basename(sound_file,".wav")
	  			js_command = "addToSelection('"+name+"','"+name+"','sound_list')"
	  			dlg.execute_script(js_command)
	  			puts name+" sound embedded!"
	  		end
	  	elsif sound_file[-4,4]==".ogg" #check if ogg file
	  		if embedMusic(sound_file) #if embedding was done add name to html selection
	  			name=File.basename(sound_file,".ogg")
	  			js_command = "addToSelection('"+name+"','"+name+"','music_list')"
	  			dlg.execute_script(js_command)
	  			puts name+" music embedded!"
	  		end
	  	else
	  		UI.messagebox "Only supports WAVE(*.wav) and Ogg Vorbis(*.ogg) files!"
	  	end
	  end
	}
	dlg.add_action_callback("play_sound"){|dialog, params|
		input=params.split('|')
		$test_sound_class.refresh() #do a refresh of embedded sounds
	  $test_sound_class.play(input[1]) if(input[0]=="sound_list")
	  $test_sound_class.playMusic(input[1],0) if(input[0]=="music_list") #play music, single loop
	}
	dlg.add_action_callback("remove_sound"){|dialog, params|
		input=params.split('|')
		if input[0]=="music_list"
			dict=Sketchup.active_model.attribute_dictionary("SPMusic") #look for embedded music
		elsif input[0]=="sound_list"
			dict=Sketchup.active_model.attribute_dictionary("SPSounds") #look for embedded sounds
		end
    if dict!=nil
    	data=dict[input[1]] #find sound to remove
    	if(data!=nil)
    		dict.delete_key(input[1]) #remove sound/music attribute_dictionary
    		js_command = "removeSelectionItem('"+input[1]+"','"+input[0]+"')"
	  		dlg.execute_script(js_command)
	  		puts input[1]+" removed!"
    	end
    end
	}
	dlg.add_action_callback("play_sound_file"){|dialog, params|
		cSound=SDL.mix_LoadWAV_RW(SDL.sDL_RWFromFile(params, "rb"),0)
    SDL.mix_PlayChannelTimed(-1, cSound, 0,-1)
	}
	
	dlg.set_on_close{
	}
end


end #module

